class net.onepixelout.audio.Playlist
{
   var _tracks;
   var _currentTrackIndex;
   var length;
   static var _cyclingEnabled = true;
   function Playlist(enableCycling)
   {
      this._tracks = new Array();
      this._currentTrackIndex = 0;
      this.length = 0;
      if(enableCycling != undefined)
      {
         net.onepixelout.audio.Playlist._cyclingEnabled = enableCycling;
      }
   }
   function loadFromList(trackList, titleList, artistList)
   {
      var _loc4_ = trackList.split(",");
      if(titleList == undefined)
      {
         titleList = "";
      }
      if(artistList == undefined)
      {
         artistList = "";
      }
      var _loc6_ = titleList.length != 0 ? titleList.split(",") : new Array();
      var _loc5_ = artistList.length != 0 ? artistList.split(",") : new Array();
      var _loc3_ = undefined;
      var _loc2_ = 0;
      while(_loc2_ < _loc4_.length)
      {
         _loc3_ = new net.onepixelout.audio.Track(_loc4_[_loc2_]);
         if(_loc2_ < _loc6_.length)
         {
            _loc3_.setTitle(_loc6_[_loc2_]);
            _loc3_.setArtist("");
         }
         if(_loc2_ < _loc5_.length)
         {
            _loc3_.setArtist(_loc5_[_loc2_]);
         }
         this.addTrack(_loc3_);
         _loc2_ = _loc2_ + 1;
      }
   }
   function loadFromXML(listXML)
   {
      var _loc3_ = listXML.firstChild.childNodes;
      var _loc2_ = 0;
      while(_loc2_ < _loc3_.length)
      {
         this.addTrack(new net.onepixelout.audio.Track(this._getNodeValue(_loc3_[_loc2_],"src"),this._getNodeValue(_loc3_[_loc2_],"title"),this._getNodeValue(_loc3_[_loc2_],"artist")));
         _loc2_ = _loc2_ + 1;
      }
   }
   function _getNodeValue(root, nodeName)
   {
      nodeName = nodeName.toLowerCase();
      var _loc1_ = 0;
      while(root.childNodes.length)
      {
         if(root.childNodes[_loc1_].nodeName.toLowerCase() == nodeName)
         {
            return root.childNodes[_loc1_].firstChild.nodeValue;
         }
         _loc1_ = _loc1_ + 1;
      }
      return null;
   }
   function getCurrent()
   {
      return this._tracks[this._currentTrackIndex];
   }
   function getCurrentIndex()
   {
      return this._currentTrackIndex;
   }
   function hasNext()
   {
      return this._currentTrackIndex < this.length - 1;
   }
   function next()
   {
      if(this.hasNext())
      {
         return this._tracks[++this._currentTrackIndex];
      }
      if(net.onepixelout.audio.Playlist._cyclingEnabled)
      {
         this._currentTrackIndex = 0;
         return this._tracks[0];
      }
      return null;
   }
   function hasPrevious()
   {
      return this._currentTrackIndex > 0;
   }
   function previous()
   {
      if(this.hasPrevious())
      {
         return this._tracks[--this._currentTrackIndex];
      }
      if(net.onepixelout.audio.Playlist._cyclingEnabled)
      {
         this._currentTrackIndex = this.length - 1;
         return this._tracks[this._currentTrackIndex];
      }
      return null;
   }
   function getAtPosition(position)
   {
      if(position >= 0 && position < this.length)
      {
         return this._tracks[position];
      }
      return null;
   }
   function addTrack(track)
   {
      this._tracks.push(track);
      this.length = this._tracks.length;
   }
   function removeAt(position)
   {
      this._tracks.splice(position,1);
      this.length = this._tracks.length;
   }
}
